package com.hyp.recordservice.record.service;

import jakarta.websocket.*;
import jakarta.websocket.server.ServerEndpoint;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.io.IOException;

@Component
@Slf4j
@ServerEndpoint("/play")
public class RecordPlaySocket {

    static Session session = null;

    @OnOpen
    public void onOpen(Session session) {
        RecordPlaySocket.session = session;
    }

    @OnClose
    public void onClose() {
        RecordPlaySocket.session = null;
    }

    @OnMessage
    public void onMessage(String messageStr) throws Exception {
//        log.info("play 收到消息：{}",messageStr);
    }

    @OnError
    public void onError(Session session, Throwable error) {
        log.error("play 用户错误,原因:"+error.getMessage());
        RecordPlaySocket.session = null;
    }

    public void sendMessage(String text) throws IOException {
//        log.info("play 发送消息：{}", text);
        if (session == null) {
            return;
        }
        synchronized(session){
            session.getBasicRemote().sendText(text);
        }
    }
}
