package com.hyp.recordservice.record.service;

import cn.hutool.extra.spring.SpringUtil;
import jakarta.annotation.Resource;
import jakarta.websocket.*;
import jakarta.websocket.server.ServerEndpoint;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;



@Component
@Slf4j
@ServerEndpoint("/push")
public class RecordPushSocket {

    @Resource
    RecordPlaySocket recordPlaySocket;

    static Session session = null;

    @OnOpen
    public void onOpen(Session session) {
        RecordPushSocket.session = session;
    }

    @OnClose
    public void onClose() {
        RecordPushSocket.session = null;
    }

    @OnMessage
    public void onMessage(String messageStr) throws Exception {
        log.info("push 收到消息：{}",messageStr);
        RecordPlaySocket socket = SpringUtil.getBean(RecordPlaySocket.class);
        socket.sendMessage(messageStr);
    }

    @OnError
    public void onError(Session session, Throwable error) {
        log.error("push 用户错误,原因:"+error.getMessage());
        RecordPushSocket.session = null;
    }

    public void sendMessage(String text){
        log.info("push 发送消息：{}", text);
        if (session == null) {
            return;
        }
        session.getAsyncRemote().sendText(text);
    }
}
